<template>
<!-- xxxxxxxxxxxxxxx S-MU-07 - 3 AUDIOS 3 IMG xxxxxxxxxxxxxxxxxxx -->
	<div class="content-audio">
			<div class="col-md-12">
			<h1>{{ value.title }}</h1>
		</div> 
		<div class="col-md-4 col-sm-4" v-for="(item, index) in value.audios" :key="index" v-viewer>
			<audio-player :can-play="!isPlaying"  @stoped="isPlaying = false" @playing="isPlaying = true" @finished="finish(index)" :sources="item.audio"></audio-player>
			<img :style="hasListenedAudio[index]" :src="item.img"><br>
			<h5>{{ item.name }}</h5>
		</div>	
		
		<Viewer :images="images">
			<img v-for="src in images" :src="src" :key="src">
		</Viewer>	
	</div>
</template>

<script>
  	import AudioPlayer 		from '../audio/audio-player.vue'  	
	import ResultTypes 		from '../../../../utils/ResultTypes'
	import { mapActions } 	from 'vuex'
	import { config }  		from './config'

	export default {
		data(){
			return {
				shouldGoDefault : false,
				isPlaying : false,
				audios: [],
				hasListenedAudio: [],
				images:[]
			}
		},
		name	: config.component,
		props	: config.props,		
		components : {AudioPlayer},
		methods : {
			...mapActions([
		    	'evaluate',
			]),
			audioIsEmpty(index){
				return !this.value.audios[index].audio.length > 0
			},
			finish(index){
				this.isPlaying = false
				let count = 0;
				this.$set(this.audios, index, true)
				this.$set(this.hasListenedAudio, index, 'border: 3px solid #43acb7;')
				for(let i = 0; i < this.audios.length; i++){
					if(this.audios[i] == false)
						count++
				}
				
				if(count == 0) 
					this.evaluate(ResultTypes.PASSED)
			},

		},
		mounted(){
			let i = 0
			for(i = 0; i < config.options.audios; i++){					
				if(this.audioIsEmpty(i)){
					this.shouldGoDefault = true
					}
				this.audios[i] = false
				this.hasListenedAudio[i] = ''
			}
			if(this.shouldGoDefault){
				toastr.warning('Falta al menos un archivo de audio por subir, evaluando por defecto.')
				setTimeout( ()=> this.evaluate(ResultTypes.PASSED), 5 * 1000)	
			}

			for(let a = 0; a < this.value.audios.length; a++){
				this.images[a] = this.audios['img'];
			}
			console.log(this.value.audios);
			toastr.info(`RECUERDA que debes reproducir los audios para pasar a la siguiente hoja.`)
		}
	}
</script>